A. Generous Kefa
 

One day Kefa found n baloons. For convenience, we denote color of i-th baloon as si — lowercase letter of the Latin alphabet. Also Kefa has k friends. Friend will be upset, If he get two baloons of the same color. Kefa want to give out all baloons to his friends. Help Kefa to find out, can he give out all his baloons, such that no one of his friens will be upset — print «YES», if he can, and «NO», otherwise. Note, that Kefa's friend will not upset, if he doesn't get baloons at all.

Input

The first line contains two integers n and k (1 ≤ n, k ≤ 100) — the number of baloons and friends.

Next line contains string s — colors of baloons.

Output

Answer to the task — «YES» or «NO» in a single line.

You can choose the case (lower or upper) for each letter arbitrary.

题意: 让你分配东西,然后每个人不能分配相同的东西   就是看看东西的种类 和 总人数的比较

#include<bits/stdc++.h>
using namespace std;
int p[];
char s[];
int main ()
{
int n,k;
cin >> n >>k;
int sum=,ans=;
for(int i=;i<n;i++)
{
cin>>s[i];
if(!p[s[i]])
sum++;
p[s[i]]++;
ans = max(ans,p[s[i]]);
}
if(ans <= k)
puts("YES");
else
puts("NO");
}
B. Godsend
 

Leha somehow found an array consisting of n integers. Looking at it, he came up with a task. Two players play the game on the array. Players move one by one. The first player can choose for his move a subsegment of non-zero length with an odd sum of numbers and remove it from the array, after that the remaining parts are glued together into one array and the game continues. The second player can choose a subsegment of non-zero length with an even sum and remove it. Loses the one who can not make a move. Who will win if both play optimally?

Input

First line of input data contains single integer n (1 ≤ n ≤ 106) — length of the array.

Next line contains n integers a1, a2, ..., an (0 ≤ ai ≤ 109).

Output

Output answer in single line. "First", if first player wins, and "Second" otherwise (without quotes).

题意:这个题  比较绕脑子,就是A可以挑一串连续的 和为奇数的子串

    B再挑和为偶数数的子串

其实 :  看过样例,多想想就会明白  如果这个串是奇数的话,那么 A一下子拿走 A就赢了

     如果串是偶数的话,那么 分两种情况 因为奇数+奇数==偶数  偶数+偶数==偶数

    考虑如果整个串都是偶数的话,那么必然 A不能拿  B能拿  B就赢了

    如果不是的话  肯定是A要取奇数  B再取偶数  然后A在取奇数     然后A就赢了

#include<bits/stdc++.h>
using namespace std;
const int maxn = 1e6+;
typedef long long ll;
int s[maxn];
ll sum[maxn]; int main ()
{
int n;
cin >> n;
for(int i=;i<=n;i++){
cin>>s[i];
sum[i] =s[i]+sum[i-];
}
if(sum[n]&)
{
cout<<"First"<<endl;
return ;
}
else
{
int ans = ;
for(int i=;i<=n;i++)
if(sum[i]%==)
{
ans++;
}
if(ans == n)
{
cout<<"Second"<<endl;
}
else
{
cout<<"First"<<endl;
}
}
}
C. Leha and Function
 

Leha like all kinds of strange things. Recently he liked the function F(n, k). Consider all possible k-element subsets of the set [1, 2, ..., n]. For subset find minimal element in it. F(n, k) — mathematical expectation of the minimal element among all k-element subsets.

But only function does not interest him. He wants to do interesting things with it. Mom brought him two arrays A and B, each consists of mintegers. For all i, j such that 1 ≤ i, j ≤ m the condition Ai ≥ Bj holds. Help Leha rearrange the numbers in the array A so that the sum  is maximally possible, where A' is already rearranged array.

Input

First line of input data contains single integer m (1 ≤ m ≤ 2·105) — length of arrays A and B.

Next line contains m integers a1, a2, ..., am (1 ≤ ai ≤ 109) — array A.

Next line contains m integers b1, b2, ..., bm (1 ≤ bi ≤ 109) — array B.

Output

Output m integers a'1, a'2, ..., a'm — array A' which is permutation of the array A.

题意 : 大概就是感觉  直接找B中最小的 和 A中最大的这样子

#include<bits/stdc++.h>
using namespace std;
const int maxn = 2e5+; int n;
struct p
{
int x;
int pos; }a[maxn],b[maxn]; int t[maxn];
bool cmp(p a,p b)
{
return a.x>b.x;
}
bool cmp1(p a,p b)
{
return a.x < b.x;
}
bool cmp2(p a,p b)
{
return a.pos < b.pos;
}
int main ()
{
ios::sync_with_stdio(false);
cin>>n;
for(int i=;i<=n;i++)
cin>>a[i].x;
for(int i=;i<=n;i++){
cin>>b[i].x;
b[i].pos = i;
}
sort(a+,a+n+,cmp);//a从大到小已经排好
sort(b+,b+n+,cmp1);//b从小到大排序
for(int i=;i<=n;i++)
{
a[i].pos = b[i].pos;
}
sort(a+,a+n+,cmp2);
for(int i=;i<=n;i++)
{
if(i==)
cout<<a[i].x;
else
cout<<" "<<a[i].x;
}
cout<<endl; }

第一次能做出来三道题 有点儿小激动...虽然还是很菜,继续坚持就好

Codeforces Round #429 (Div. 2)的更多相关文章

  1. CodeForces 840C - On the Bench | Codeforces Round #429 (Div. 1)

    思路来自FXXL中的某个链接 /* CodeForces 840C - On the Bench [ DP ] | Codeforces Round #429 (Div. 1) 题意: 给出一个数组, ...

  2. CodeForces 840B - Leha and another game about graph | Codeforces Round #429(Div 1)

    思路来自这里,重点大概是想到建树和无解情况,然后就变成树形DP了- - /* CodeForces 840B - Leha and another game about graph [ 增量构造,树上 ...

  3. CodeForces 840A - Leha and Function | Codeforces Round #429 (Div. 1)

    /* CodeForces 840A - Leha and Function [ 贪心 ] | Codeforces Round #429 (Div. 1) A越大,B越小,越好 */ #includ ...

  4. 【Codeforces Round #429 (Div. 2) A】Generous Kefa

    [Link]:http://codeforces.com/contest/841/problem/A [Description] [Solution] 模拟,贪心,每个朋友尽量地多给气球. [Numb ...

  5. Codeforces Round #429 (Div. 2/Div. 1) [ A/_. Generous Kefa ] [ B/_. Godsend ] [ C/A. Leha and Function ] [ D/B. Leha and another game about graph ] [ E/C. On the Bench ] [ _/D. Destiny ]

    PROBLEM A/_ - Generous Kefa 题 OvO http://codeforces.com/contest/841/problem/A cf 841a 解 只要不存在某个字母,它的 ...

  6. 【Codeforces Round #429 (Div. 2) C】Leha and Function

    [Link]:http://codeforces.com/contest/841/problem/C [Description] [Solution] 看到最大的和最小的对应,第二大的和第二小的对应. ...

  7. 【Codeforces Round #429 (Div. 2) B】 Godsend

    [Link]:http://codeforces.com/contest/841/problem/B [Description] 两个人轮流对一个数组玩游戏,第一个人可以把连续的一段为奇数的拿走,第二 ...

  8. Codeforces Round #429 (Div. 2) 补题

    A. Generous Kefa 题意:n个气球分给k个人,问每个人能否拿到的气球都不一样 解法:显然当某种气球的个数大于K的话,就GG了. #include <bits/stdc++.h> ...

  9. Codeforces Round #429 Div. 1

    A:甚至连题面都不用仔细看,看一下样例就知道是要把大的和小的配对了. #include<iostream> #include<cstdio> #include<cmath ...

  10. Codeforces Round #429 (Div. 1) C. On the Bench(dp + 组合数)

    题意 一个长度为 \(n\) 的序列 \(A\) ,定义一个 \(1\) 到 \(n\) 的排列 \(p\) 是合法的,当且仅当 \(\forall i \in [1, n − 1], A_{p_i} ...

随机推荐

  1. Windows下搭建Git服务器各种问题汇总(一)

    **************************************************************************************************** ...

  2. Unity无法创建新工程

    1.解决方法 重新登录一遍账号

  3. vue学习五之VueCLi

    概念 通俗的说,Vue CLI是我们创建大型项目时的脚手架,所谓脚手架,就是帮助我们建设好了建造大厦的所需模板,建设者只需往模板里面填入实质内容,即可完成大厦的建设,对于程序开发来说,脚手架使程序员只 ...

  4. win10 java环境变量的正确配置

    变量名:[JAVA_HOME]变量值:[D:\Program Files\Java\jdk1.8.0_92][jdk安装路径]变量名:[Path]变量值:[;%JAVA_HOME%\bin;%JAVA ...

  5. itertools模块(收藏)

    Python的内建模块itertools提供了非常有用的用于操作迭代对象的函数. count().cycle().repeat() 首先,我们看看itertools提供的几个“无限”迭代器: > ...

  6. Floyd 判圈算法

    Floyd 判圈算法 摘自维基百科, LeetCode 上 141题 Linked List Cycle 用到这个, 觉得很有意思. 记录一下. 链接: https://zh.wikipedia.or ...

  7. iOS 开发笔记-plist使用

    1.创建一个plist 2.填写为ImageList.plist 3.填入数据 4.完成 加载代码: @interface UYViewController () //图片信息的数组 @propert ...

  8. div 在css中透明度怎么调?

    可以用这个属性:opacity: 0.95;opacity为属性,0.95为值(其中值的范围在0~1之间) 参考:https://zhidao.baidu.com/question/689118188 ...

  9. Javascript-闰年javascript的判断

    <!DOCTYPE html> <html lang="en"> <head> <meta charset="UTF-8&quo ...

  10. VS2012快捷键突然不能用怎么办

    晚上做项目做着做着,就去弄了下键盘配置,可怜的娃娃~~~一下子弄得什么快捷键都不能用了,比如”注释:ctrl+k ctrl+c”;问题纠结了我一个多钟,好在最后结合了网络上各路英雄的idea;解决了问 ...